#!/bin/bash

# status variables
Args=("$@")
SetPrint=0
SetDepth=0
SetOutput=0
SetTreeFile=0
SetVerbose=0
Depth=0
OutputFile="CurrentTree"
TreeFile="CurrentTree"
ProtocolFile=""


Executable=/usr/bin/swipl

# parse arguments into status vars
i=0
while [ $i -le $# ]; do
	if [ "${Args[$i]}" = "-v" ]; then
		SetVerbose=1
	fi
	if [ "${Args[$i]}" = "-p" ]; then
		SetPrint=1
		TreeFile="${Args[`expr $i + 1`]}"
		i=`expr $i + 1`
	fi
	if [ "${Args[$i]}" = "-d" ]; then
		SetDepth=1
		Depth="${Args[`expr $i + 1`]}"
		i=`expr $i + 1`
	fi
	if [ "${Args[$i]}" = "-t" ]; then
		SetTreeFile=1
		TreeFile="${Args[`expr $i + 1`]}"
		i=`expr $i + 1`
	fi
	if [ "${Args[$i]}" = "-o" ]; then
		SetOutput=1
		OutputFile="${Args[`expr $i + 1`]}"
		i=`expr $i + 1`
	fi
	if [ "${Args[$i]}" = "-e" ]; then
		Executable="${Args[`expr $i + 1`]}"
		i=`expr $i + 1`
	fi
	if [ $i -eq `expr $# - 1` ]; then
		if [ $SetPrint -eq 0 ]; then ProtocolFile="${Args[$i]}"; fi
	fi
	i=`expr $i + 1`
done


# run SWI-Prolog with set status vars
# only print
if [ $SetPrint -eq 1 ]; then
	if [ $SetDepth -eq 1 ]; then
		exec $Executable -f exec.pl -g "exec_print_tree('$TreeFile', $Depth)"
		exit
	fi
	exec $Executable -f exec.pl -g "exec_print_tree('$TreeFile')"
	exit
fi
# strategy finding
if [ $SetTreeFile -eq 1 ]; then
	exec $Executable -G100000 -f exec.pl -g "exec_run('$ProtocolFile', '$TreeFile', $SetVerbose)"
	exit
fi
if [ $SetOutput -eq 1 ]; then
	exec $Executable -G100000 -f exec.pl -g "exec_run_without_treefile_outputfile('$ProtocolFile', $OutputFile, $SetVerbose)"
	exit
fi
exec $Executable -G100000 -f exec.pl -g "exec_run_without_treefile('$ProtocolFile', $SetVerbose)"








































