%% MAIN
:-
	set_prolog_flag(verbose_load, false),

	[tools,
	output,
	mtree,
	example,
	transitions,
	tree_buildup,
	constraints,
	solver,
	strategy_helper,
	strategy_finder,
	read_protocol].
%% END_MAIN

% examples from files
alicex :-
	retractall(alicex(_)),
	read_protocol_file('ASW_Alice', A, _),
	full_tree(A,T),
	get_variable_tree(T, _, VX),
	assert(alicex(VX)), !.
alicep :-
	alicexp(T,_),
	retractall(alicexp(_,_)),
	read_protocol_file('ASW_Alice', _, PP),
	assert(alicexp(T,PP)), !.
alicexp :-
	retractall(alicexp(_,_)),
	read_protocol_file('ASW_Alice', A, PP),
	full_tree(A,T),
	get_variable_tree(T, _, VX),
	assert(alicexp(VX,PP)), !.
bobx :-
	retractall(bobx(_)),
	read_protocol_file('ASW_Bob', A, _),
	full_tree(A,T),
	get_variable_tree(T, _, VX),
	assert(bobx(VX)), !.
bobxp :-
	retractall(bobxp(_,_)),
	read_protocol_file('ASW_Bob', A, PP),
	full_tree(A,T),
	get_variable_tree(T, _, VX),
	assert(bobxp(VX, PP)), !.

% quick examples
tmp(T) :-
	init_node(X),
	full_tree(X,T).
tmpA(T) :-
	asw_alice(A),
	full_tree(A,T).
tmpAn(T) :-
	asw_alice_newsig(A),
	full_tree(A,T).
tmpB(T) :-
	asw_bob(B),
	full_tree(B,T).
vtmp(VT) :-
	tmp(T),
	get_variable_tree(T, _, VT).
vtmp(VT, SL) :-
	tmp(T),
	get_variable_tree(T, SL, VT).
























































