
out(sst(I,M,S,T,Pi,PIK,L,R,ST)) :-
	out_tree(sst(I,M,S,T,Pi,PIK,L,R,ST), 0).
out(sst(I,M,S,T,P,PIK,L,R,ST), MaxLvl) :-
	ML is MaxLvl * 4,
	out_tree_maxlvl(sst(I,M,S,T,P,PIK,L,R,ST), ML, 0).
out(sst(I,M,T,L,R,ST)) :-
	out_tree(sst(I,M,T,L,R,ST), 0).
outp(T) :-
	out_p(T, 0).
outi(T) :-
	writeln('________'),
	out_index_tree(T, 0).
outil(TL) :-
	out_index_tree_list(TL, 0).

out_index_tree(sst(I,M,_,_,_,_,_,_,ST), DEPTH) :-
	tab(DEPTH), writef("%w:%w\n",[I,M]),
	D2 is DEPTH + 1,
	out_index_tree_list(ST, D2).
out_index_tree_list([], _).
out_index_tree_list([T|Ts], DEPTH) :-
	out_index_tree(T, DEPTH),
	out_index_tree_list(Ts, DEPTH).

% sst(_9_)
out_tree(sst(I,_M,state(_,IK,_),T,_,_,L,R,NL), DEPTH) :-
	tab(DEPTH), writef("______________________________\n"),
	D is DEPTH + 2,
	DW is DEPTH / 4,
	write(DW), writef(":"), tab(D), writef("Node Index:  "), write(I), nl,
	%write(DW), writef(":"), tab(D), writef("Marked:  "), write(M), nl,
	write(DW), writef(":"), tab(D), writef("Trans.Type:  "), write(T), nl,
	write(DW), writef(":"), tab(D), writef("LHS / RHS:   "), write(L), writef(" => "), write(R), nl,
	write(DW), writef(":"), tab(D), writef("IK: "), writeln(IK),
	out_tree_list(NL, D).
% sst(_9_)
out_tree_maxlvl(_, MaxLvl, MaxLvl) :- !.
out_tree_maxlvl(sst(I,_M,state(_,IK,_),T,_,_,L,R,NL), MaxLvl, DEPTH) :-
	tab(DEPTH), writef("______________________________\n"),
	D is DEPTH + 2,
	DW is DEPTH / 4,
	write(DW), writef(":"), tab(D), writef("Node Index:  "), write(I), nl,
	%write(DW), writef(":"), tab(D), writef("Marked:  "), write(M), nl,
	write(DW), writef(":"), tab(D), writef("Trans.Type:  "), write(T), nl,
	write(DW), writef(":"), tab(D), writef("LHS / RHS:   "), write(L), writef(" => "), write(R), nl,
	write(DW), writef(":"), tab(D), writef("IK: "), writeln(IK),
	out_tree_list_maxlvl(NL, MaxLvl, D).
% sst(_6_): logtreeformat
out_tree(sst(I,M,T,L,R,NL), DEPTH) :-
	tab(DEPTH), writef("______________________________\n"),
	D is DEPTH + 2,
	DW is DEPTH / 4,
	write(DW), writef(":"), tab(D), writef("Node Index:  "), write(I), nl,
	write(DW), writef(":"), tab(D), writef("Marked:  "), write(M), nl,
	write(DW), writef(":"), tab(D), writef("Trans.Type:  "), write(T), nl,
	write(DW), writef(":"), tab(D), writef("LHS / RHS:   "), write(L), writef(" => "), write(R), nl,
	out_tree_list(NL, D).

out_tree_list([], _).
out_tree_list([N|Ns], DEPTH) :-
	D is DEPTH + 2,
	out_tree(N, D),
	out_tree_list(Ns, DEPTH).
out_tree_list_maxlvl([], _, _).
out_tree_list_maxlvl([N|Ns], ML, DEPTH) :-
	D is DEPTH + 2,
	out_tree_maxlvl(N, ML, D),
	out_tree_list_maxlvl(Ns, ML, DEPTH).

% constraint system
output_c(constraint(X,IK)) :-
	writef("%36l :",[X]),
	writeln(IK).
	%output_l(IK), nl.
output_cs([]).
output_cs([C|Cs]) :-
	output_c(C),
	output_cs(Cs).

out_p(sst(_,_,state(PL,_,_),_,_,_,_,_,ST), DEPTH) :-
	tab(DEPTH), writef("______________________\n"),
	D is DEPTH + 2,
	%DW is DEPTH / 2,
	%write(DW), writef(":"),
	output_pl(PL, D),
	out_p_list(ST, D).
out_p_list([], _).
out_p_list([N|Ns], DEPTH) :-
	out_p(N, DEPTH),
	out_p_list(Ns, DEPTH).
% principal successor output
output_ps([], _).
output_ps([S|Ss], DEPTH) :-
	output_ps(S, DEPTH),
	output_ps(Ss, DEPTH).
output_ps(ps(rule(X,Y), Children), DEPTH) :-
	tab(DEPTH), writef("%w => %w\n", [X,Y]),
	output_p(Children, DEPTH).
% principal list output
output_pl([], _).
output_pl([P|Ps], DEPTH) :-
	output_p(P, DEPTH),
	output_pl(Ps, DEPTH).
% principal output
output_p(p([]), _).
output_p(p([C|Cs]), DEPTH) :-
	tab(DEPTH), writef("principal:\n"),
	D is DEPTH + 2,
	output_ps(C, D),
	output_ps(Cs, D).

% a constraint system in solver-form
out_cs([]).
out_cs([[L,R]|Cs]) :-
	%writef("%w:\n%15r\n",[L,R]),
	writef("______________________\n      %w:\n",[L]),
	out_cs_rightside(R),
	% writef("______________\n"),
	out_cs(Cs).
out_cs([constraint(L,R)|Cs]) :-
	writef("______________________\n      %w:\n",[L]),
	out_cs_rightside(R),
	% writef("______________\n"),
	out_cs(Cs).
out_cs_rightside([]).
out_cs_rightside([R|Rs]) :-
	writef("%5r %w\n",['*',R]),
	out_cs_rightside(Rs).




% consider intruder knowledge for output
outik(sst(I,M,S,T,Pi,PIK,L,R,ST)) :-
	out_tree_ik(sst(I,M,S,T,Pi,PIK,L,R,ST), 0).
% sst(_9_)
out_tree_ik(sst(I,M,state(_,IK,_),T,_,PIK,L,R,NL), DEPTH) :-
	tab(DEPTH), writef("______________________________\n"),
	D is DEPTH + 2,
	DW is DEPTH / 4,
	write(DW), writef(":"), tab(D), writef("Node Index:  "), write(I), nl,
	write(DW), writef(":"), tab(D), writef("Marked:  "), write(M), nl,
	write(DW), writef(":"), tab(D), writef("Trans.Type:  "), write(T), nl,
	write(DW), writef(":"), tab(D), writef("LHS / RHS:   "), write(L), writef(" => "), write(R), nl,
	writef("%w:",[DW]), tab(D), writef("IK:  %w\n",[IK]),
	writef("%w:",[DW]), tab(D), writef("PIK: %w\n",[PIK]),
	out_tree_list_ik(NL, D).
out_tree_list_ik([], _).
out_tree_list_ik([N|Ns], DEPTH) :-
	D is DEPTH + 2,
	out_tree_ik(N, D),
	out_tree_list_ik(Ns, DEPTH).

% print vars within LHS and RHS instead of the terms themselves
outv(sst(I,M,S,T,Pi,PIK,L,R,ST)) :-
	out_tree_v(sst(I,M,S,T,Pi,PIK,L,R,ST), 0).
% sst(_9_)
out_tree_v(sst(I,M,state(_,_IK,_),T,_,_PIK,L,R,NL), DEPTH) :-
	tab(DEPTH), writef("______________________________\n"),
	D is DEPTH + 2,
	DW is DEPTH / 4,
	write(DW), writef(":"), tab(D), writef("Node Index:  "), write(I), nl,
	write(DW), writef(":"), tab(D), writef("Marked:  "), write(M), nl,
	write(DW), writef(":"), tab(D), writef("Trans.Type:  "), write(T), nl,
	varstermwrap(L,VL),varstermwrap(R,VR),
	write(DW), writef(":"), tab(D), writef("VarsL / VarsR:  %w => %w\n",[VL,VR]),
	out_tree_list_v(NL, D).
out_tree_list_v([], _).
out_tree_list_v([N|Ns], DEPTH) :-
	D is DEPTH + 2,
	out_tree_v(N, D),
	out_tree_list_v(Ns, DEPTH).

% print principals
outprinc(sst(I,M,S,T,Pi,PIK,L,R,ST)) :-
	out_tree_princ(sst(I,M,S,T,Pi,PIK,L,R,ST), 0).
% sst(_9_)
out_tree_princ(sst(I,M,state(PL,_IK,_),T,_,_PIK,_L,_R,NL), DEPTH) :-
	tab(DEPTH), writef("______________________________\n"),
	D is DEPTH + 2,
	DW is DEPTH / 4,
	write(DW), writef(":"), tab(D), writef("Node Index:  "), write(I), nl,
	write(DW), writef(":"), tab(D), writef("Marked:  "), write(M), nl,
	write(DW), writef(":"), tab(D), writef("Trans.Type:  "), write(T), nl,
	output_pl(PL,D),
	out_tree_list_princ(NL, D).
out_tree_list_princ([], _).
out_tree_list_princ([N|Ns], DEPTH) :-
	D is DEPTH + 2,
	out_tree_princ(N, D),
	out_tree_list_princ(Ns, DEPTH).
